% Programa para el calculo de solidos 2D con elementos de barra lineales
% con grados de liberad de desplazamiento (Reticulados planos)
% Autor: Mg. Ing. Javier L. Mroginski
% Versin: 1.0 (2008)
clc;
clear;
close all;

display('------------------------ EFIR2D v 1.0 ---------------------------') 
display(' Programa para el clculo de reticulados planos empleando el MEF')
display(' Autor: Mg. Ing. Javier L. Mroginski')
display(' Versin: 1.0 (2008)')
display('-----------------------------------------------------------------') 

coord = load('coordenadas_nodales.txt')
loads = load('cargas_nodales.txt')
conec = load('conectividades.txt')
fixed = load('cond_borde.txt')

nload = size(loads,1);
nelem = size(conec,1);
nnodo = 2;
ndime = size(coord,2);
npoin = size(coord,1);
nfixe = size(fixed,1);
despG=zeros(2*npoin,1);

plotter(coord,conec,nelem,nnodo,'b-') %grafica la malla indeformada con azul
xlabel ('Coordenada X [m]');
ylabel ('Coordenada Y [m]');
legend('Malla indeformada');
hold on

FGlob = EnsamblajeF(loads,npoin,nload,ndime);
[KGlob] = EnsamblajeK(npoin,nnodo,ndime,nelem,coord,conec);
[KGcon,FGcon,ifixe] = CondBorde(KGlob,FGlob,npoin,nfixe,fixed);

fprintf('\n---Desplazamientos nodales---\n\n') 
despl=KGcon\FGcon;
despG(find(ifixe(:,1)==1))=ifixe(find(ifixe(:,1)==1),2);
despG(find(ifixe(:,1)==0))=despl;
for ipoin=1:npoin
  pos = (ipoin-1)*ndime+1;
  fprintf (' Nodo: %3i \t Desplazamiento en X = %12.5e \t Desplazamiento en Y = %12.5e \n',ipoin, despG(pos),despG(pos+1)); 
end

fprintf('\n---Reacciones exteriores--- \n\n') 
reac=KGlob*despG;
for ipoin=1:npoin
  pos = (ipoin-1)*ndime+1;
  fprintf (' Nodo: %3i \t Desplazamiento en X = %7.3f \t Desplazamiento en Y = %7.3f \n',ipoin, reac(pos),reac(pos+1)); 
end


%display('Deformacin de cada elemento') 
%defor= Deformacion(nelem,despG,conec,coord);
%grafico(coord,nnodo,despl)

corda=actual_coord(coord,npoin,despG);

graphic(nelem,nnodo,coord,corda,conec)
%plotter(corda,conec,nelem,nnodo,'ro-')  %grafica la malla deformada con rojo
hold off
